Page MenuHomeFreeBSD

D24303.id70243.diff
No OneTemporary

D24303.id70243.diff

Index: tests/sys/net/Makefile
===================================================================
--- tests/sys/net/Makefile
+++ tests/sys/net/Makefile
@@ -5,6 +5,7 @@
TESTSDIR= ${TESTSBASE}/sys/net
BINDIR= ${TESTSDIR}
+ATF_TESTS_SH+= if_carp
ATF_TESTS_C+= if_epair
ATF_TESTS_SH+= if_bridge_test
ATF_TESTS_SH+= if_clone_test
Index: tests/sys/net/if_carp.sh
===================================================================
--- /dev/null
+++ tests/sys/net/if_carp.sh
@@ -0,0 +1,76 @@
+# $FreeBSD$
+#
+# SPDX-License-Identifier: BSD-2-Clause-FreeBSD
+#
+# Copyright (c) 2020 Kristof Provost <kp@FreeBSD.org>
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+
+. $(atf_get_srcdir)/../common/vnet.subr
+
+atf_test_case "carp_basic" "cleanup"
+carp_basic_head()
+{
+ atf_set descr 'Basic CARP test'
+ atf_set require.user root
+}
+
+carp_basic_body()
+{
+ if ! kldstat -q -m carp; then
+ atf_skip "This test requires carp"
+ fi
+
+ vnet_init
+ bridge=$(vnet_mkbridge)
+ epair_one=$(vnet_mkepair)
+ epair_two=$(vnet_mkepair)
+
+ vnet_mkjail one ${bridge} ${epair_one}a ${epair_two}a
+ vnet_mkjail two ${epair_one}b
+ vnet_mkjail three ${epair_two}b
+
+ jexec one ifconfig ${bridge} 192.0.0.4/29 up
+ jexec one ifconfig ${bridge} addm ${epair_one}a addm ${epair_two}a
+ jexec one ifconfig ${epair_one}a up
+ jexec one ifconfig ${epair_two}a up
+
+ jexec two ifconfig ${epair_one}b 192.0.0.2/29 up
+ jexec two ifconfig ${epair_one}b add vhid 1 192.0.0.1/29
+
+ jexec three ifconfig ${epair_two}b 192.0.0.3/29 up
+ jexec three ifconfig ${epair_two}b add vhid 1 192.0.0.1/29
+
+ sleep 3
+
+ atf_check -s exit:0 -o ignore jexec one ping -c 10 192.0.0.1
+}
+
+carp_basic_cleanup()
+{
+ vnet_cleanup
+}
+
+atf_init_test_cases()
+{
+ atf_add_test_case "carp_basic"
+}

File Metadata

Mime Type
text/plain
Expires
Wed, Sep 25, 8:44 AM (9 h, 26 m)
Storage Engine
blob
Storage Format
Raw Data
Storage Handle
12748431
Default Alt Text
D24303.id70243.diff (2 KB)

Event Timeline